using System.Collections.Generic;
using System.Linq;
using BepInEx;
using BepInEx.Configuration;
using HarmonyLib;
using Amplitude;
using Amplitude.Mercury.Data.Simulation;
using Amplitude.Mercury.Data.World;
using Amplitude.Mercury.Terrain;
using Amplitude.Mercury.UI;

namespace AOM.Humankind.EraStarCatchupFame
{

    [BepInPlugin(PLUGIN_GUID, "Era Star Catchup Fame", "1.0.0.0")]
    public class EraStarCatchupFame : BaseUnityPlugin
    {
        const string PLUGIN_GUID = "AOM.Humankind.EraStarCatchupFame";
        void Awake()
        {
            var harmony = new Harmony(PLUGIN_GUID);
            harmony.PatchAll();
            this.FameBonus = Config.Bind("General",
                                        nameof(FameBonus),
                                         100f,
                                         "Base fame bonus for a catchup star.");
            InitLog();
            Instance = this;
        }

        public ConfigEntry<float> FameBonus { get; private set; }

        public static EraStarCatchupFame Instance;


        public string GetFameLogFolder()
        {
            return System.IO.Path.Combine(Amplitude.Framework.Application.GameDirectory, "Temporary Files");
        }
        public string GetFameLogFilePath()
        {
            return System.IO.Path.Combine(GetFameLogFolder(), $"FameLog.log");
        }
        public void InitLog()
        {
            var dir = new System.IO.DirectoryInfo(GetFameLogFolder());
            if (!dir.Exists) dir.Create();
            var fp = GetFameLogFilePath();
            System.IO.File.CreateText(fp).Close();
        }
        public void LogFame(int turn, string player,string context, FixedPoint gain, FixedPoint total)
        {
            var fp = GetFameLogFilePath();
            using (var fs = new System.IO.StreamWriter(fp, true))
            {
                fs.WriteLine($"[{System.DateTime.Now}] Turn {turn} {player} gains {gain}. Total {total}\t Context: {context}");
            }
        }
        public void LogKetchup(int turn, string player)
        {

            var fp = GetFameLogFilePath();
            using (var fs = new System.IO.StreamWriter(fp, true))
            {
                fs.WriteLine($"[{System.DateTime.Now}] Turn {turn} {player} gains fame from catchup star.");
            }

        }
    }
}
